JUCE: ParameterAttachment Class Reference

JUCE

Public Member Functions | List of all members
ParameterAttachment Class Reference
juce_audio_processors » utilities

Used to implement 'attachments' or 'controllers' that link a plug-in parameter to a UI element. More...

`#include <juce_ParameterAttachments.h>`

Inheritance diagram for ParameterAttachment:

## Public Member Functions
| ParameterAttachment (RangedAudioParameter &parameter, std::function< void(float)> parameterChangedCallback, UndoManager *undoManager=nullptr)
| Listens to a parameter and calls the the provided function in response to parameter changes. More...
| ~ParameterAttachment () override
| Destructor. More...
void | sendInitialUpdate ()
| Calls the parameterChangedCallback function that was registered in the constructor, making the UI reflect the current parameter state. More...
void | setValueAsCompleteGesture (float newDenormalisedValue)
| Triggers a full gesture message on the managed parameter. More...
void | beginGesture ()
| Begins a gesture on the managed parameter. More...
void | setValueAsPartOfGesture (float newDenormalisedValue)
| Updates the parameter value during a gesture. More...
void | endGesture ()
| Ends a gesture on the managed parameter. More...

## Detailed Description

Used to implement 'attachments' or 'controllers' that link a plug-in parameter to a UI element.

To implement a new attachment type, create a new class which includes an instance of this class as a data member. Your class should pass a function to the constructor of the ParameterAttachment, which will then be called on the message thread when the parameter changes. You can use this function to update the state of the UI control. Your class should also register as a listener of the UI control and respond to respond to changes in the UI element by calling either setValueAsCompleteGesture or beginGesture, setValueAsPartOfGesture and endGesture.

Make sure to call `sendInitialUpdate` at the end of your new attachment's constructor, so that the UI immediately reflects the state of the parameter.

## Constructor & Destructor Documentation

## ◆ ParameterAttachment()

ParameterAttachment::ParameterAttachment | ( | RangedAudioParameter & | parameter,
|  | std::function< void(float)> | parameterChangedCallback,
|  | UndoManager * | undoManager = `nullptr`
| ) |  |

Listens to a parameter and calls the the provided function in response to parameter changes.

If an undoManager is supplied `beginNewTransaction` will be called on it whenever the UI requests a parameter change via this attachment.

Parameters

  parameter | The parameter to which this attachment will listen
  parameterChangedCallback | The function that will be called on the message thread in response to parameter changes
  undoManager | The UndoManager that will be used to begin transactions when the UI requests a parameter change.

## ◆ ~ParameterAttachment()

ParameterAttachment::~ParameterAttachment | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ sendInitialUpdate()

void ParameterAttachment::sendInitialUpdate | ( |  | ) |

Calls the parameterChangedCallback function that was registered in the constructor, making the UI reflect the current parameter state.

This function should be called after doing any necessary setup on the UI control that is being managed (e.g. adding ComboBox entries, making buttons toggle-able).

## ◆ setValueAsCompleteGesture()

void ParameterAttachment::setValueAsCompleteGesture | ( | float | newDenormalisedValue | ) |

Triggers a full gesture message on the managed parameter.

Call this in the listener callback of the UI control in response to a one-off change in the UI like a button-press.

## ◆ beginGesture()

void ParameterAttachment::beginGesture | ( |  | ) |

Begins a gesture on the managed parameter.

Call this when the UI is about to begin a continuous interaction, like when the mouse button is pressed on a slider.

## ◆ setValueAsPartOfGesture()

void ParameterAttachment::setValueAsPartOfGesture | ( | float | newDenormalisedValue | ) |

Updates the parameter value during a gesture.

Call this during a continuous interaction, like a slider value changed callback.

## ◆ endGesture()

void ParameterAttachment::endGesture | ( |  | ) |

Ends a gesture on the managed parameter.

Call this when the UI has finished a continuous interaction, like when the mouse button is released on a slider.

The documentation for this class was generated from the following file:

- juce_ParameterAttachments.h